/////////////////////////////////////////////////////////////////////////////////////////////
//Startpunkt und Startgeschwindigkeit von n "Planeten" per Maus eingeben
//Danach mit Mausklick starten: Planetenbahnen werden gezeichnet. Planete werden dargestellt.
//////////////////////////////////////////////////////////////////////////////////

ArrayList<Planet> planete;
PVector ort;
PVector geschwindigkeit;
PVector startOrt;
PVector startGeschwindigkeit;
ArrayList<PVector> punkte;//Spurpunkte
double[] X,Y,x,y,x0,y0,x1,y1,x2,y2;//Orte
double r,R;
double[] Vx,Vy,vx0,vy0,vx,vy;//Geschwindigkeiten
double[][] vRK;
double[][] aRK;
int radiusPlanet,radiusZentralkoerper;
color [] farbe;
double M;//Masse des anderen Körpers
int n ,i, I,z, nullEins;
double dt;//Schrittweite
double alpha =0;
double G;//Gravitationskonstante
boolean fertig;
boolean [] zerstoert;
boolean neuStart;
boolean mitReibung = false;
/////////////////////////////////////////////////////////////////
void setup() {
  size(800, 800,P3D);
  background(0);
  stroke(255);
  initialisieren();
 
}
/////////////////////////////////////////////////////////////////////////////////////
void draw() {  
  if(!neuStart){  
    println(neuStart);
    translate(width/2,height/2);//Ursprung in der Bildmitte  
    fill(255);noStroke();
    lights();
    sphere(radiusZentralkoerper);    
    if(fertig){ 
      background(0);
      fill(255);noStroke();
      sphere(radiusZentralkoerper);  
      for (Planet b : planete) b.setUpdated(false);//alle Planete wieder nicht-upgedatet setzen
      for (Planet b : planete) {     
        b.aktualiseren();
        b.display();      
      }
      for(int j=0;j<n;j++){
         fill(farbe[j]); noStroke();
         ellipse((float)x2[j],(float)y2[j],10,10);
         ellipse((float)x1[j],(float)y1[j],5,5);  
         strokeWeight(3); stroke(farbe[j]);
         line((float)x2[j],(float)y2[j],(float)x1[j],(float)y1[j]);
      }    
      for(int K =0; K<n; K++){                 
             if(!zerstoert[K])stroke(farbe[K]); 
             else stroke(color(0));
             strokeWeight(2);
             for(int i =K; i< punkte.size()-n ;i=i+n){         
               line(punkte.get(i).x,punkte.get(i).y,punkte.get(i+n).x,punkte.get(i+n).y);
             }             
      }
    }  
  }else{
    background(0);
    planete.clear();
    punkte.clear();
    initialisieren();
    neuStart=false;
   
    
  }
}
/////////////////////////////////////////////////////////////////////////////////////
vierDContainer RK4Grav(double X , double Y, double Vx, double Vy){//Runge-Kutta-4 Algorithmus
  r= Math.sqrt(X*X+Y*Y);R=r*r*r;
  vRK[0][0] = Vx;                         aRK[0][0] = -M*G*X/R;     
  vRK[1][0] = Vy;                         aRK[1][0] = -M*G*Y/R; 
  
  r= Math.sqrt(Math.pow(X+0.5*vRK[0][0]*dt,2)+Math.pow(Y+0.5*vRK[1][0]*dt,2));R=r*r*r;
  vRK[0][1] =vRK[0][0] + 0.5*aRK[0][0]*dt ;     aRK[0][1] = -M*G/R*(X+ 0.5*vRK[0][0]*dt); 
  vRK[1][1] =vRK[1][0] + 0.5*aRK[1][0]*dt ;     aRK[1][1] = -M*G/R*(Y+ 0.5*vRK[1][0]*dt); 
  
  r= Math.sqrt(Math.pow(X+0.5*vRK[0][1]*dt,2)+Math.pow(Y+0.5*vRK[1][1]*dt,2)); R=r*r*r;  
  vRK[0][2] =vRK[0][0] + 0.5*aRK[0][1]*dt ;     aRK[0][2] = -M*G/R*(X+ 0.5*vRK[0][1]*dt);     
  vRK[1][2] =vRK[1][0] + 0.5*aRK[1][1]*dt ;     aRK[1][2] = -M*G/R*(Y+ 0.5*vRK[1][1]*dt); 
  
  r= Math.sqrt(Math.pow(X+vRK[0][2]*dt,2)+Math.pow(Y+vRK[1][2]*dt,2)) ; R=r*r*r; 
  vRK[0][3] = vRK[0][0] + aRK[0][2]*dt ;      aRK[0][3] = -M*G/R*(X+ vRK[0][2]*dt);  
  vRK[1][3] = vRK[1][0] + aRK[1][2]*dt ;      aRK[1][3] = -M*G/R*(Y +vRK[1][2]*dt); 
  
  X = X + (vRK[0][0] + 2*vRK[0][1] + 2*vRK[0][2] + vRK[0][3])/6*dt; 
  Y = Y + (vRK[1][0] + 2*vRK[1][1] + 2*vRK[1][2] + vRK[1][3])/6*dt; 
  
  Vx = Vx + (aRK[0][0] + 2*aRK[0][1] + 2*aRK[0][2] + aRK[0][3])/6*dt;
  Vy = Vy + (aRK[1][0] + 2*aRK[1][1] + 2*aRK[1][2] + aRK[1][3])/6*dt;
  if(mitReibung){
     float qV = sq((float)Vx)+sq((float)Vy);
     Vx = Vx*(1-qV*0.000002); Vy = Vy*(1-qV*0.000002);
  }
  return new vierDContainer(X,Y, Vx, Vy);
}
//////////////////////////////////////////////////////////////////////////////////////
void mousePressed() { //Planete setzen - Anfangsbedingungen werden dadurch festgelegt.
  
  if(I<n){
    if(nullEins%2==0){
       x0[I]= map(mouseX,0,width,-width/2,width/2); 
       y0[I]= map(mouseY,0,height,-height/2,height/2);   
       x2[I]= x0[I]; y2[I]= y0[I];  
       ort =new PVector((float)x0[I],(float)y0[I]);     
       fill(farbe[I]); noStroke();ellipse((float)x2[I],(float)y2[I],10,10);
       
       nullEins++;
    }else{
       x1[I]= map(mouseX,0,width,-width/2,width/2); 
       y1[I]= map(mouseY,0,height,-height/2,height/2);
       vx0[I] =  (x1[I]-x0[I])/50; vy0[I] =  (y1[I]-y0[I])/50 ;       
       geschwindigkeit = new PVector((float)vx0[I],(float)vy0[I]);
       fill(farbe[I]); noStroke();ellipse((float)x1[I],(float)y1[I],5,5);
       strokeWeight(3); stroke(farbe[I]);line((float)x2[I],(float)y2[I],(float)x1[I],(float)y1[I]);
       planete.add(new Planet(ort, radiusPlanet, geschwindigkeit, farbe[I],I));
       nullEins++; I++;
    }  
   
  }else {  
          fertig=true; 
        }
}
//////////////////////////////////////////////////////////////
void initialisieren(){
   n = 3;
  dt =0.5;
  z = 0; 
  G=800;
  M = 0.5; //zentrale Masse
  I=0;
  nullEins =0;
  fertig = false;
  neuStart = false;
  colorMode(HSB,256,256,256,256);
  planete = new ArrayList<Planet>();
  x = new double[n];
  y = new double[n];
  vx = new double[n];
  vy = new double[n];  
  x0 = new double[n];
  y0 = new double[n];
  vx0 = new double[n];
  vy0 = new double[n];
  x1 = new double[n];
  y1 = new double[n];
  x2 = new double[n];
  y2 = new double[n];
  zerstoert = new boolean[n];
  vRK = new double[2][4];//2 Dimension, 4 Anzahl Komponenten
  aRK = new double[2][4];//              "  
  punkte = new ArrayList<PVector>();
  radiusPlanet =12;
  radiusZentralkoerper = 10;
  farbe = new color[n];
  float delta = 255/(float)n; 
  for(int i=0;i<n;i++){ 
    farbe[i] = color(delta*i,255,255);
    zerstoert[i] = false;
  } 
}
/////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  if(key=='r'){
    if(mitReibung){
      mitReibung = false;
      println("Keine Reibung!");
    }else{
      mitReibung = true;
      println("Mit Reibung!");
    }
  }  
  if(key=='n'){//Neustart
    neuStart=true;   
  }
}
/////////////////////////////////////////////////////////////////////////////////////////
class vierDContainer//Klasse zur bequemen Rückgabe mehrer Größen
  {
    double X,Y, Vx, Vy;  
    
    vierDContainer(double X, double Y, double Vx, double Vy){
    this.X =X;
    this.Y =Y;
    this.Vx = Vx;
    this.Vy = Vy;
  }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
class Planet {//Planet-Klasse
  private PVector position;
  private PVector geschwindigkeit;
  private float radius;
  private color farbe;
  private int nummer;
  private boolean isUpdated;

  Planet(PVector p, float r, PVector v, color f, int n) {
    position = p;
    geschwindigkeit = v;
    radius = r;
    farbe = f;
    nummer = n;
  }
  
  void setPos(PVector pos) { position = new PVector(pos.x,pos.y); }
  
  void setGeschw(PVector geschw) { geschwindigkeit = new PVector(geschw.x,geschw.y); }
  
  void setDeleted() { farbe = color(0);  }
  
  PVector getPos() { return position; }
  
  PVector getGeschw() { return geschwindigkeit; }
  
  int getNummer() {return nummer;}
  
  void aktualiseren() { //nach jedem draw-Durchlauf für alle i
      int K = this.getNummer();
      x[K]= RK4Grav(x0[K],y0[K],vx0[K],vy0[K]).X; 
      y[K]= RK4Grav(x0[K],y0[K],vx0[K],vy0[K]).Y;
      vx[K]= RK4Grav(x0[K],y0[K],vx0[K],vy0[K]).Vx;
      vy[K]= RK4Grav(x0[K],y0[K],vx0[K],vy0[K]).Vy;                    
      x0[K] = x[K];y0[K] = y[K];
      vx0[K]=vx[K];vy0[K]=vy[K];
             
      position.x = (float)x0[K];
      position.y = (float)y0[K];
      geschwindigkeit.x=(float)vx0[K];
      geschwindigkeit.y=(float)vy0[K];
      
      int s =this.getNummer();      
      Planet planetD = planete.get(s);
      float r = sqrt(sq(planetD.getPos().x)+sq(planetD.getPos().y));
      if(r < radiusZentralkoerper+2){
        planetD.setDeleted();
        zerstoert[s] = true;       
      }     
      punkte.add(new PVector(position.x,position.y)); 
  }
  
  void setUpdated(boolean v) { 
    isUpdated = v;
  }
  boolean wasUpdated() { 
    return isUpdated;
  }
   void display() {  
    noStroke();
    lights();
    fill(farbe);
    pushMatrix();
    translate(position.x, position.y, 0);
    sphere(radius);//3D- Effekt
    popMatrix();
  }
}
